/*
 File: eolsym.cpp
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#include "eol.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_eol;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_eol::TH_eol(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_eol;
  NS_eol::Ceol Ceol_;// parallel-parser's parse table
#define ssPARSE_TABLE Ceol_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_eol::PROC_TH_eol(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_eol";
  static bool one_time(false);
  static NS_eol::Ceol* NS_eol_Ceol_(0);// parallel-parser's fsm table
  static Parser* NS_eol_Ceol_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_eol_Ceol_ = new NS_eol::Ceol();// parallel-parser's fsm table
    NS_eol_Ceol_parser = new Parser(*NS_eol_Ceol_,Caller_pp);
  }
 proc_parser = NS_eol_Ceol_parser;
#include "wproc_pp_core.h"
}
void 
Ceol::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Reol_:{
       Reol* sym;
     if(re->rule_ == 0){
       sym = new Reol(parser__);
       re->rule_ = sym;
     }else{
       sym = (Reol*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs3_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    default: return;
   }
}
